<?php
/**
 * @author info@senbyte.com
 * @copyright 2016 senByte UG
 * @license
 */

include_once $oPlugin->cAdminmenuPfad . 'inc/easyCreditDefinitions.php';
require_once $oPlugin->cAdminmenuPfad . 'inc/easyCreditHelper.class.php';
require_once str_replace('frontend', '', $oPlugin->cFrontendPfad) . 'easycredit-sdk/autoload.php';
require_once str_replace('frontend', 'paymentmethod', $oPlugin->cFrontendPfad) . '/class/EasyCredit.class.php';

use EasyCredit\Api\ApiClient as ecClient;
use EasyCredit\Api\DataMapper as ecMapper;
use EasyCredit\Config as ecConfig;

$ecHelper          = easyCreditHelper::getInstance($oPlugin);
$easyCredit        = new EasyCredit();
$requestAdapter    = new \EasyCredit\Http\Adapter\Curl();
$from              = array('.', ' &euro;', ',');
$to                = array('', '', '.');

$request = new EasyCredit\Http\Request(
    \EasyCredit\Config::EASYCREDIT_API_HOSTNAME, \EasyCredit\Config::EASYCREDIT_API_PORT, $requestAdapter
    );

$apiClient = new ecClient(
    $easyCredit->webshopId,
    $easyCredit->token,
    $request,
    new ecMapper()
    );

if ($ecHelper->getPageType() == PAGE_ARTIKEL) {
    $widgetEnabled = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_article_display'];

    if ($widgetEnabled==="1") {
        pq('head')->append('<link type="text/css" href="' . $oPlugin->cFrontendPfadURLSSL . 'css/style.css" rel="stylesheet" />');
        
        $pqMethodArticle   = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_article_method'];
        $pqSelectorArticle = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_article_selector'];

        $tpl_vars     = $smarty->get_template_vars();
        $price        = $tpl_vars['Artikel']->Preise->fVKBrutto;
        $monthlyCosts = $apiClient->getBest($price);
        $value        = $monthlyCosts->getAmountOfRate();
        $imageUrl     = $oPlugin->cFrontendPfadURLSSL . 'images/rk.png';
        $infoLink     = sprintf(ecConfig::EXAMPLE_CALCULATION_LINK, $easyCredit->webshopId, $price);
        $financeFrom  = str_replace(
            '%VALUE%',
            $value,
            $oPlugin->oPluginSprachvariableAssoc_arr["jtl_ec_widget_finance_from"]
        );
        $ecSmartyVars = [
            'imageUrl' => $imageUrl,
            'financeFrom' => $financeFrom,
            'infoLink' => $infoLink,
            'moreInfo' => $oPlugin->oPluginSprachvariableAssoc_arr["jtl_ec_widget_more_information"]
        ];
            
        $smarty->assign($ecSmartyVars);
        
        $articleWidgetTpl = $smarty->fetch($oPlugin->cFrontendPfad . '/template/articleWidget.tpl');
        
        pq($pqSelectorArticle)->$pqMethodArticle($articleWidgetTpl);
    }
} elseif ($ecHelper->getPageType() == PAGE_BESTELLVORGANG
    && pq(SELECTOR_PAYMENT_OPTION_PAGE)->length > 0) {

        if (isset($_GET['ec_dec'])) {
            $decisionResponse = $easyCredit->getEcProcess()->getDecision();
            if ($decisionResponse != null) {
                $message = utf8_decode($decisionResponse->getDecision()->getBoilerplate());
                Shop::Smarty()->assign('hinweis', $message);
                $notificationTpl = $smarty->fetch($oPlugin->cFrontendPfad . '/template/notification.tpl');
        
                pq('form#zahlung fieldset')->prepend($notificationTpl);
                $easyCredit->setSelectable(false);
                pq('#' . $easyCredit->pluginName . ' input[type=radio]:first')->attr('disabled', 'disabled');
            }
        }
        
        $tpl_vars = $smarty->get_template_vars();
        
        pq('head')->append('<script type="text/javascript" src="' . $oPlugin->cFrontendPfadURLSSL .'js/paymentOption_checkbox.js"></script>');
        pq('head')->append('<link type="text/css" href="' . $oPlugin->cFrontendPfadURLSSL . 'css/style.css" rel="stylesheet" />');
        
        $price            = str_replace($from, $to, $tpl_vars['WarenkorbGesamtsumme'][0]);
        $installmentPlans = $apiClient->get($price);
        $ecSmartyVars     = [
            'checkboxId' => $easyCredit->pluginName . '_consent',
            'legislativeText' => utf8_decode($apiClient->getLegislativeText()->getDataProcessingPaymentPage()),
            'installmentPlans' => $installmentPlans->getResults(),
            'isSelectable' => $easyCredit->isSelectable()
        ];
        
        $smarty->assign($ecSmartyVars);
        
        $paymentOptionTpl = $smarty->fetch($oPlugin->cFrontendPfad . '/template/paymentOption.tpl');
        
        pq('#' . $easyCredit->pluginName . ' ' . SELECTOR_PAYMENT_OPTION_PAGE_EC)->append($paymentOptionTpl);
} elseif (
    $ecHelper->getPageType() == PAGE_BESTELLSTATUS || 
    $ecHelper->getPageType() == PAGE_BESTELLABSCHLUSS ||
    ($ecHelper->getPageType() == PAGE_BESTELLVORGANG && $smarty->get_template_vars()['step']=='Bestaetigung')) {
    
    $tpl_vars = $smarty->get_template_vars();
    
    if ($ecHelper->getPageType() == PAGE_BESTELLVORGANG) {
        $selectedPaymentMethod = Session::get('Zahlungsart')->cModulId;
    } else {
        $selectedPaymentMethod = $tpl_vars['Bestellung']->Zahlungsart->cModulId;
    }

    if ($selectedPaymentMethod === $easyCredit->pluginName) {
        pq('head')->append('<link type="text/css" href="' . $oPlugin->cFrontendPfadURLSSL . 'css/style.css" rel="stylesheet" />');
        
        if ($ecHelper->getPageType() == PAGE_BESTELLSTATUS) {
            $pqMethod        = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_status_method'];
            $pqSelector      = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_status_selector'];
            $showInfo        = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_status_display'];
            $ecAddSmartyVars = [
                'theader' => false,
                'tfooter' => false,
                'colspan' => 3,
                'currency' => $tpl_vars['Bestellung']->Waehrung->cNameHTML
            ];
        } elseif ($ecHelper->getPageType() == PAGE_BESTELLABSCHLUSS) {
            $pqMethod        = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_confirmation_method'];
            $pqSelector      = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_confirmation_selector'];
            $showInfo        = 1;
            $ecAddSmartyVars = [
                'theader' => true,
                'tfooter' => true,
                'colspan' => 1,
                'currency' => $tpl_vars['Bestellung']->Waehrung->cNameHTML,
                'orderValue' => $tpl_vars['Bestellung']->cBestellwertLocalized
            ];
        } elseif ($ecHelper->getPageType() == PAGE_BESTELLVORGANG) {
            $pqMethod        = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_finalize_method'];
            $pqSelector      = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_finalize_selector'];
            $showInfo        = $oPlugin->oPluginEinstellungAssoc_arr['jtl_easycredit_finalize_display'];
            $currency        = substr($tpl_vars['WarensummeLocalized'][0] , stripos($tpl_vars['WarensummeLocalized'][0], ' '));
            $ecAddSmartyVars = [
                'theader' => false,
                'tfooter' => false,
                'colspan' => 4,
                'currency' => $currency
            ];
        }
        
        if ($showInfo) {
            $financingDetails = $easyCredit->getEcProcess()->getFinancingDetails();
            $installmentPlan  = $financingDetails->getInstallmentPlan();
            $commonData       = $easyCredit->getEcProcess()->getCommonProcessData();
            $contractURL      = $commonData->getCommonProcessData()->getContractInfoURL();
            $paymentText      = $commonData->getPaymentPlanText();
            $interest         = $installmentPlan->getInterestRate()->getAccruingInterest();
            $total            = $installmentPlan->getAmount();
            
            $ecSmartyVars = [
                'installmentInfo' => $oPlugin->oPluginSprachvariableAssoc_arr["jtl_ec_confirmation_installment_info"],
                'orderValueTitle' => $oPlugin->oPluginSprachvariableAssoc_arr["jtl_ec_confirmation_order_value"],
                'interestValueTitle' =>  $oPlugin->oPluginSprachvariableAssoc_arr["jtl_ec_confirmation_interest_value"],
                'contractUrlTitle' => $oPlugin->oPluginSprachvariableAssoc_arr["jtl_ec_confirmation_contract_information"],
                'totalValueTitle' =>$oPlugin->oPluginSprachvariableAssoc_arr["jtl_ec_confirmation_total_value"],
                'interestValue' => $interest,
                'totalValue' => $total,
                'contractUrl' => $contractURL,
                'paymentText' => $paymentText
            ];
            $ecSmartyVars = array_merge($ecSmartyVars, $ecAddSmartyVars);
    
            $smarty->assign($ecSmartyVars);
            
            $financingDetailsTpl = $smarty->fetch($oPlugin->cFrontendPfad . '/template/financialDetails.tpl');
    
            pq($pqSelector)->$pqMethod($financingDetailsTpl);
        }
    }
} elseif (
    null !== Session::get('ec_error_msg')
    ) {
        Shop::Smarty()->assign('hinweis', $oPlugin->cName . ': ' . Session::get('ec_error_msg'));
        $notificationTpl = $smarty->fetch($oPlugin->cFrontendPfad . '/template/notification.tpl');
        pq('#checkout_steps')->after($notificationTpl);
        Session::set('ec_error_msg', null);
}
?>
