<?php

/**
 * @author info@senbyte.com 
 * @copyright 2016 senByte UG
 * @license 
 */

if (!class_exists('easyCreditHelper'))
{
    class easyCreditHelper
    {
        /**
         * @var null|easyCreditHelper
         */
        private static $instance = null;

        /**
         * @var null|bool
         */
        private static $isShopV4 = null;

        /**
         * constructor
         *
         * @param Plugin $oPlugin
         */
        public function __construct(Plugin $oPlugin)
        {

        }

        /**
         * get instance
         *
         * @param Plugin $oPlugin
         * @return easyCreditHelper
         */
        public static function getInstance(Plugin $oPlugin)
        {
            return (null === self::$instance) ? new self($oPlugin) : self::$instance;
        }

        /**
         * check if there is a current shop version installed
         *
         * @return bool
         */
        public static function isShopV4()
        {
            if (null === self::$isShopV4) {
                self::$isShopV4 = version_compare(JTL_VERSION, 400, '>=') && class_exists('Shop');
            }

            return self::$isShopV4;
        }

        /**
         * 
         * @return unknown
         */
        public static function getPageType()
        {
            if (self::$isShopV4 === true) {
                return Shop::getPageType();
            } else {
                return gibSeitenTyp();
            }
        }
    }
}